# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#####################################
# Copyright (c) 2016 Peter Buchholz #
#####################################
############################################
#
# sla_add_zero
#
# input: A matrix of the type
#        A {a1 a2 an}
#        where ai = [xi, yi, si]
#
# output B matrix which starts at x = 0 y = 0
#        if ncessary a linear segemnt
#        (0,0,0)(x0,0,0) is added for a curve 
#        that starts at (x0,y0,s0).
#
###########################################
function B = sla_add_zero(A)

   if (A{1}(1) > 0)
      if (A{1}(2) == 0)   
      	 B = {[0, 0, 0]} ;
	 j = 1 ;
      else
         B = {[0, 0, 0], [A{1}(1),0,0]} ;
	 j = 2 ;
      endif
      for (i=1:columns(A))
	  B{i+j} = A{i} ;
      endfor
   else
      B = A ;
   endif

endfunction