# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#####################################
# Copyright (c) 2016 Peter Buchholz #
#####################################
############################################
#
# sla_curve_to_xy.m
# input: leng x value up to wish the y and yvalues are computed
#        A matrix of the type
#        A {a1 a2 an}
#        where ai = [xi, yi, si]
#       
# output x, y corrdinates of the curve which can be plotted
#
###########################################
function [x, y] = sla_curve_to_xy(leng, A)
 
   xend = 0.0 ;
   amax = columns(A) ;
   if (amax == 0)
      # degnerated curve
      x(1) = 0 ;
      y(1) = 0 ;
      x(2) = leng ;
      y(2) = 0 ;
      return ;
   endif	
   i = 1 ;
   if (A{1}(1) == 0 && A{1}(2) == 0)
      j = 1 ;
   else
      x(1) = 0 ;
      y(1) = 0 ;
      j = 2 ;
   endif
   while (xend < leng)
     x(j) = A{i}(1) ;
     y(j) = A{i}(2) ;
     xend = x(j) ;
     j++ ;	     
     if (i < amax)
       i++ ;
       if (A{i}(1) <= leng)
         newval = y(j-1) + A{i-1}(3)*(A{i}(1)-x(j-1)) ;
	 if (newval != A{i}(2))
	   x(j) = A{i}(1) ;	
	   y(j) = y(j-1) + A{i-1}(3)*(x(j)-x(j-1)) ;
	   xend = x(j) ;
	   j++ ;
	 endif
       else
          x(j) = leng ;
	  y(j) = y(j-1) + A{i-1}(3)*(leng-x(j-1)) ;
	  xend = leng ;
       endif  
     else
       x(j) = leng ;
       y(j) = y(j-1) + A{i}(3)*(leng-x(j-1)) ;
       xend = leng ;
     endif 
   endwhile
   if (!(sla_check_curve(A)))
     printf("Curve is partially decreasing\n") ;    
   endif
endfunction