# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#####################################
# Copyright (c) 2016 Peter Buchholz #
#####################################
############################################
#
# sla_is_infinite.m
# input: AC delay or arrival curve
#       
#       
# output  infini
#
# description: The function yields true if the
#              curve is infinite in some components.
#
###########################################
function infini = sla_is_infinite(AC)

  infini = false ;
  for (i = 1:columns(AC))
     if (AC{i}(2) == Inf || AC{i}(3) == Inf)
        infini = true ;
	return ;
     endif
  endfor
endfunction