# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#####################################
# Copyright (c) 2016 Peter Buchholz #
#####################################
############################################
#
# sla_reduce_segemnt
#
# input: xx, yy sequences of x and y values
#  
#
# output xxr yyr x and y values where redundant parts have been removed
#
###########################################
function [xxr, yyr] = sla_reduce_segment(xx, yy)

  if (length(xx) != length(yy))
     printf("Fatal input error in function sla_reduce_segement\n") ;
     exit(-1) ;
  else
     j = 1 ;
     for (i=1:length(xx))
        if (i == 1 || abs(xx(i)-xx(i-1)) > 1.0e-12 || abs(yy(i)-yy(i-1)) > 1.0e-12)
	   xxr(j) = xx(i) ;
	   yyr(j) = yy(i) ;
	   j++ ;
	endif
     endfor
  endif
endfunction