# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#####################################
# Copyright (c) 2016 Peter Buchholz #
#####################################
############################################
#
# sla_sub
#
# input: A, B matrices of the type
#        A {a1 a2 an}
#        where ai = [xi, yi, si]
#
# output C = max(A - B, 0)
#
###########################################
function C = sla_sub(A, B)

   for (i = 1:columns(B))
       B{i}(2) = -B{i}(2) ;
       B{i}(3) = -B{i}(3) ;
   endfor
   D = sla_add(A,B) ; 
   j = 1 ;
   for (i=1:columns(D))
       if (abs(D{i}(3)) < 1.0e-12)
	  D{i}(3) = 0 ;
       endif
       if (D{i}(2) >= 0)
	  C{j} = D{i} ;
	  j++ ;
       	  if (D{i}(3) < 0)
	     xzero = D{i}(1) - D{i}(2) / D{i}(3) ;
	     if (i == columns(D) || xzero < D{i}(1))
	     	C{j} = [xzero, 0, 0] ;
		j++ ;
	     endif
	  endif
       else
	  C{j} = [D{i}(1), 0, 0] ;
	  j++ ;
       endif
   endfor
endfunction