# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#####################################
# Copyright (c) 2016 Peter Buchholz #
#####################################
############################################
#
# sla_test_upper_limit.m
# input: A0, A1  matrices of the type
#        {a1 a2 an}
#        where ai = [xi, yi, si]
#       
# output true if in the limit A0 has a rate
#        which does not exceed the rate of A1,
#        false otherwise
#
###########################################
function ok = sla_test_upper_limit(A0, A1)

  s0 = A0{columns(A0)}(3) ;
  s1 = A1{columns(A1)}(3) ;
  if (s0 <= s1 + 1.0e-12)
    ok = true;
  else
    ok = false ;
  endif
endfunction